/**
  *  \file planetscentral/talk/newsrc.h
  *  \brief Talk: User newsrc access
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_NEWSRC_H
#define C2SERVER_PLANETSCENTRAL_TALK_NEWSRC_H

#include "planetscentral/dbclient/dbsubtree.h"

/** Newsrc. Stores a set of postings the user already read.
    Optimized for conserving space. */
class Newsrc {
 public:
    Newsrc(DbSubtree root);

    void save();

    bool get(int32_t messageId);
    void set(int32_t messageId);
    void clear(int32_t messageId);

 private:
    DbInt index();
    DbHash data();

    void loadCache(int32_t index);
    void doLoad(int32_t index);

    DbSubtree root;

    int32_t readAllBelowLine;

    /** Cache. */
    string_t cache;
    int32_t cacheIndex;
    bool cacheDirty;
};

#endif
